
#include "FGCSM.h"
int setlabel(int label[][32])
{
  int i,j,l;
  label[0][0]=0;
  label[1][0]=N/2;
  l=2;
  for(i=2;i<N;i++)
    {
      if(i%2==0)
	{
	  for(j=0;j<(pow(2,(i/2-1)));j++)
	    {
	      label[i][j]=(1+4*j)/(pow(2,(i/2+1)))*N;
	      l++;
	    }
	}
      else 
	{
	  for(j=0;j<(pow(2,(i/2-1)));j++)
	    {
	      label[i][j]=(3+4*j)/(pow(2,(i/2+1)))*N;
	      l++;
	    }
	}
      if(l==N)break;
    }
  return i+1;
}
////////////////////////////////////////////////////////////////////////////////////////
int Aset(int *label,int BP,int i)
{
  int j;
  int dif=0,Nlabel=0;
  Nlabel=label[0];
 
  for(j=1;j<pow(2,(i/2-1));j++)
    {    
      if(abs(label[j]-BP)<abs(Nlabel-BP)) Nlabel=label[j];
    }
  return Nlabel;
}
////////////////////////////////////////////////////////////////////////////////////////
double DC(IplImage* limg, IplImage* rimg, int x, int y,int width,int height,int f)
{
    if (x < (f+WINDOW/2)||(x+WINDOW/2)>width) return 10000;
    if (y < (WINDOW/2)||(y+WINDOW/2)>height) return 10000;
  int i,j;
  double cost=0;
  for(i=-WINDOW/2;i<=WINDOW/2;i++)
    {
      for(j=-WINDOW/2;j<=WINDOW/2;j++)
	{
	  cost+=abs((double)limg->imageData[(y+j)*width+x+i]-(double)rimg->imageData[(y+j)*width+x+i-f]);
	}
    }
  return cost/(WINDOW*WINDOW);//abs(limg.imageData[y+x]-rimg.imageData[y+x-f]);
}
////////////////////////////////////////////////////////////////////////////////////////
int SC(int fp,int fq)
{
  return C*abs(fp-fq);
}

/////////////////////////////////////////////////////////////////////////////////////////
int main(){
   typedef Graph<int, int, int> GraphType;
   srand((unsigned)time(NULL));

   int i,j;
   int x,y;
   int A[32][32];
   int labelnum;
   int E=1000000000;
   int newE;
   int success;
   int AP,AQ;
   int BP,BQ;
   int VA,VB;
   int APOS;
   GraphType* graph=NULL;

 clock_t t1, t2;
   t1 = clock();


    IplImage* rightimg = cvLoadImage("rightb.bmp",CV_LOAD_IMAGE_GRAYSCALE);
    IplImage* leftimg= cvLoadImage("leftb.bmp",CV_LOAD_IMAGE_GRAYSCALE);

    if(leftimg==NULL || rightimg==NULL ){
        fprintf(stderr,"読み込み失敗\n");
        return 1;
    }
    const int width=leftimg->width;
    const int height=leftimg->height;
    const int nodenum=width*height;
    ///////////////
    labelnum=setlabel(A);
		printf("%d\n",A[0][0]);
		printf("%d\n",A[1][0]);
      for(i=2;i<labelnum;i++)
      {
	for(j=0;j<(pow(2,(i/2-1)));j++)
	    {    
		printf("%d ",A[i][j]);
	    }
	  printf("\n");
      }
      //
      IplImage* resimg = cvCreateImage(cvSize(width, height), IPL_DEPTH_8U, 1);    
      unsigned int B[width][height];
      printf("%d %d\n",resimg->width,width);
      printf("%d %d\n",resimg->height,height);
      for (y=0; y<height; y++) {
	    for (x=0; x<width; x++) {
  	      B[x][y] =0;//rightimg->imageData[y*width+x];
	      cvSet2D(resimg,(y*width+x)/width,(y*width+x)%width,cvScalar(255*B[x][y]/N));
	      //resimg->imageData[y*width+x]=leftimg->imageData[y*width+x];
	    }
	  }
	  i=0;
	  while(i<ROOP)
	    {
	      success=0;
	      for(j=0;j<(labelnum+1);j++)
		{
		  graph = new GraphType(3*nodenum, 6*nodenum);
		  // newE=0;
	      APOS=nodenum;
		  for (y=0; y<height; y++) {
		    for (x=0; x<width; x++) {
		      BP=B[x][y];
		      AP=Aset(A[j],BP,j);
		      graph -> add_node();
		      graph -> add_tweights(y*width+x, DC(leftimg, rightimg, x, y,width,height,BP), DC(leftimg, rightimg, x, y,width,height, AP));	
		    }
		  }
		  for (y=0; y<height; y++) {
		    for (x=0; x<width; x++) {
		      if((x+1)<width)
			{
			  BP=B[x][y];
			  BQ=B[x+1][y];
			  AP=Aset(A[j],BP,j);
			  AQ=Aset(A[j],BQ,j);
			  VA=SC(AP,AQ);
			  VB=SC(BP,BQ);
			  graph -> add_node();
			  graph -> add_tweights(APOS, VB,VA);	
			  if(VB<=VA)
			    {
			      graph -> add_edge(APOS, y*width+x, NWEIGHT, max(SC(AP,BQ)-VB, 0));
			      graph -> add_edge(APOS, y*width+x+1, NWEIGHT, max(SC(BP,AQ)-VB, 0));
			    }
			  else 
			    {
			      graph -> add_edge(APOS, y*width+x, max(SC(AP,BQ)-VA, 0),NWEIGHT);
			      graph -> add_edge(APOS, y*width+x+1, max(SC(BP,AQ)-VA, 0),NWEIGHT);
			      }
			  APOS++;
			}

		      if((y+1)<height)
			{
			  BP=B[x][y];
			  BQ=B[x][y+1];
			  AP=Aset(A[j],BP,j);
			  AQ=Aset(A[j],BQ,j);
			  VA=SC(AP,AQ);
			  VB=SC(BP,BQ);
			  graph -> add_node();
			  graph -> add_tweights(APOS,  VB, VA);	
			  if(VB<=VA)
			    {
			      graph -> add_edge(APOS, y*width+x, NWEIGHT, max(SC(AP,BQ)-VB, 0));
			      graph -> add_edge(APOS, (y+1)*width+x, NWEIGHT, max(SC(BP,AQ)-VB, 0));
			    }
			  else 
			    {
			      graph -> add_edge(APOS, y*width+x, max(SC(AP,BQ)-VA, 0),NWEIGHT);
			      graph -> add_edge(APOS, (y+1)*width+x, max(SC(BP,AQ)-VA, 0),NWEIGHT);
			    }
			  APOS++;
			}

		    }
		    
		  }

		  int flow=graph->maxflow();

		  newE= flow;

		  if(newE<E){
		    E=newE;
		    success=1;
		    for (int y=0; y<height; y++) {
		      for (int x=0; x<width; x++) {
			if (graph -> what_segment(y*width+x) == GraphType::SOURCE) {
			  B[x][y]=Aset(A[j],B[x][y],j);
			}
		      }
		    }
		  }
		  delete graph;
		  printf("E=%d\n",E);
		}
	      printf("\n");
	      if(success==0)break;
	    }

	  for (int y=0; y<height; y++) {
	    for (int x=0; x<width; x++) {
	      cvSet2D(resimg,(y*width+x)/width,(y*width+x)%width,cvScalar(255*B[x][y]/N));
	    }
	  }
	  cvNamedWindow("result",CV_WINDOW_AUTOSIZE);
	  cvShowImage("result",resimg);
	  cvSaveImage("result.bmp",resimg);
	  t2 = clock();
	  printf("%f\n", (double)(t2 - t1) / CLOCKS_PER_SEC);
	       cvWaitKey();
         cvDestroyAllWindows();

      return 0;
}
